package com.example.mmad.testapp.Listner;

import com.example.mmad.testapp.entity.UserEntity;
import com.example.mmad.testapp.event.UserCreatedEvent;
import com.example.mmad.testapp.repository.UserSnapshotRepository;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.stereotype.Component;

@Component
public class UserEventListener {
    private final UserSnapshotRepository userSnapshotRepository;

    public UserEventListener(UserSnapshotRepository userSnapshotRepository) {
        this.userSnapshotRepository = userSnapshotRepository;
    }

    @KafkaListener(topics = "user-created", containerFactory = "kafkaListenerContainerFactory", groupId = "test")
    public void updatedUserSnapshot(UserCreatedEvent user) {
        UserEntity userSnapshot = new UserEntity();
        //Todo write an mapper
        userSnapshot.setId(user.getUserId());
        userSnapshot.setUserName(user.getUsername());
        userSnapshot.setEmail(user.getEmail());
        userSnapshotRepository.save(userSnapshot);
        System.out.println("snapshot is updated" + user.getUserId());
//        userSnapshotRepository.save(userSnapshot);
    }

}
