package com.example.mmad.testapp.command;

import com.example.mmad.testapp.entity.OrderEntity;
import com.example.mmad.testapp.event.OrderCreatedEvent;
import com.example.mmad.testapp.repository.OrderRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.stereotype.Service;

@Service
public class OrderCommandHandler {
    @Autowired
    private ApplicationEventPublisher applicationEventPublisher;
    private final OrderRepository orderRepository;

    public OrderCommandHandler(OrderRepository orderRepository) {
        this.orderRepository = orderRepository;
    }

    public void createUser(CreateOrderCommand createOrderCommand) {
        OrderEntity orderEntity = new OrderEntity();
        orderEntity.setId(createOrderCommand.getOrderId());
        orderEntity.setOrderName(createOrderCommand.getOrderName());
        orderEntity.setDescription(createOrderCommand.getDescription());
        orderEntity.setUserId(createOrderCommand.getUserId());
        orderRepository.save(orderEntity);
        OrderCreatedEvent event = new OrderCreatedEvent(
                orderEntity.getId(),
                orderEntity.getOrderName(),
                orderEntity.getDescription(),
                orderEntity.getUserId()
        );
        applicationEventPublisher.publishEvent(event);
    }
}
