package com.example.mmad.testapp.controller;

import com.example.mmad.testapp.command.CreateOrderCommand;
import com.example.mmad.testapp.command.OrderCommandHandler;
import com.example.mmad.testapp.entity.view.ViewOrder;
import com.example.mmad.testapp.service.ViewOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

@RestController
@RequestMapping("/order")
public class OrderController {

    private OrderCommandHandler orderCommandHandler;
    private ViewOrderService viewOrderService;

    @Autowired
    public void setPersonService(OrderCommandHandler orderCommandHandler, ViewOrderService viewOrderService) {
        this.orderCommandHandler = orderCommandHandler;
        this.viewOrderService = viewOrderService;
    }

    @PostMapping("/list")
    public ResponseEntity<List<ViewOrder>> list() {
        return ResponseEntity.ok(viewOrderService.listInfo());
    }

    @CrossOrigin(origins = "http://localhost:3001")
    @PostMapping("/create")
    public ResponseEntity<?> create(@Valid @RequestBody CreateOrderCommand orderCommand) {
        orderCommandHandler.createUser(orderCommand);
        return ResponseEntity.ok(200);
    }
}
