package com.example.mmad.testapp.query;

import com.example.mmad.testapp.entity.OrderQueryEntity;
import com.example.mmad.testapp.event.OrderCreatedEvent;
import com.example.mmad.testapp.repository.OrderReadRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.event.EventListener;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;

@Component
public class UserQueryHandler {
    @Autowired
    private OrderReadRepository orderReadRepository;

    @Async("taskExecutor")
    @EventListener
    public void handelUserCreated(OrderCreatedEvent event) {
        OrderQueryEntity orderQueryEntity = new OrderQueryEntity();
        orderQueryEntity.setId(event.getOrderId());
        orderQueryEntity.setOrderName(event.getOrderName());
        orderQueryEntity.setDescription(event.getDescription());
        orderQueryEntity.setUserId(event.getUserId());
        orderReadRepository.save(orderQueryEntity);
        System.out.println("Received user created event" + event.getOrderId());
    }
}
